<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */
/**
 * Jakie moga byc parametry przekazane do funckcji:
 *
 * param - nazwa parametru, wowczas bedzie szuka po nazwie
 * param_id - identyfikator parametru
 *
 * cecha - nazwa cechy
 * cecha_id  - identyfikator cechy
 *
 *
 *
 * @param type $params
 * @param type $smarty
 *
 */

function smarty_function_search_param($params, &$smarty){
    $options = array(); $option_name = ''; $divId = '';

    get_parametry();
    if(!isset($params['multi']) ){
        $params['multi'] = true;
    }

    if ( !empty($params['param'])  ) {
        $search = strtolower($params['param']);

        $parametry  = get_parametry();
        foreach( $parametry as $id => $param ){
            if ( str2lower($param['NAZWA']) == $search ){
                $params['param_id'] = $id;
                $params['param'] = $param;

                break;
            }
        }
    } else if( !empty( $params['cecha'] ) ){
        $search = strtolower($params['cecha']);

        $cechy  = get_cechy();
        foreach( $cechy as $id => $cecha ){
            if ( str2lower($cecha) == $search ){
                $params['cecha_id'] = $id;
                
                break;
            }
        }
    }

    if ( !empty($params['param_id'])  ) {
        $option_name = 'params['.$params['param_id'].']'. ( $params['multi'] ? '[]' : '');
        $divId = 'paramSearch-'. $params['param_id'];
		$option_key = 'params';
		$option_key_id = 'param_id';
        $options = get_parametr_wartosci($params['param_id']);
    } else if( !empty( $params['cecha_id'] ) ){
        $option_name = 'cechy['.$params['cecha_id'].']' . ( $params['multi'] ? '[]' : '');
        $divId = 'cechaSearch-'. $params['cecha_id'];
		$option_key = 'cechy';
		$option_key_id = 'cecha_id';
        $options = get_cecha_wartosci($params['cecha_id']);
    }

    if ( $options ) {
        if ( !empty($params['select']) ) {
			$selected = array();
			$script_params = $smarty->get_template_vars('script_params');
			
			if(!empty($script_params[$option_key][$params[$option_key_id]])){
				$selected = (array)$script_params[$option_key][$params[$option_key_id]];
			}
			
            echo '<select name="'.$option_name.'" '.( $params['multi'] ? 'multiple="multiple"' : '' ).'>';
			if(isset($params['empty'])){
				echo '<option value="">'.$params['empty'].'</option>';
			}
            foreach ( $options as $id => $option) {
				$checked = '';
				if(!empty($selected) && in_array($id,$selected)){
					$checked = ' selected="selected" ';
				}
                echo '<option value="'.$id.'" "'.$checked.'">'.$option['NAZWA'].'</option>';
            }
            echo '</select>';
        } else {
            $input_type = $params['multi'] ? 'checkbox' : 'radio';
            $input_id = !empty($params['param_id']) ? 'paramSearchInput' : 'cechaSearchInput';
			
			$selected = array();
			$script_params = $smarty->get_template_vars('script_params');
			
			if(!empty($script_params[$option_key][$params[$option_key_id]])){
				$selected = $script_params[$option_key][$params[$option_key_id]];
			}
			
			echo '<div id="'.$divId.'" >';
            foreach ( $options as $id => $option) {
				$label = $checked = '';
				if(!empty($selected) && in_array($id,$selected)){
					$checked = ' checked="checked" ';
				}
                if( !empty($option['IMG_URL']) ){
                    $label = '<img src="'.$option['IMG_URL'].'" alt="'.htmlspecialchars($option['NAZWA']).'" />';
                } else if( !empty($option['HTML']) ){
                    $label = $option['HTML'];
                } else {
                    $label = $option['NAZWA'];
                }

                echo '<label for="'.$input_id.$id.'"><input type="'.$input_type.'" name="'.$option_name.'" id="'.$input_id . $id.'" value="'.$id.'" '.$checked.' /> '.$label.'</label>';
            }
            echo '</div>';
        }
    }
}

