<?php
/**
 * Plugin wyswietla towary producenta, przykad wywoania
 *
 *    {towary_producenta producent_id=12}
 *
 * W takim wypadku zostanie wywietlonych 10 towarw producenta, mona do funckcji
 * perzekaza parametr ilosc ktry okresli liczb wyswietlonych towarw danego producenta
 *
 *    {towary_producenta producent_id=12 ilosc=20}
 *
 * W takim wypadku zostanie wyswietlonych ilosc rekordw.
 *
 * Dodatkowo do funkcji mona przekaza paramter ajax, ale aby zadziaa on poprawnie musi
 * zosta zmieniony katalog wyswietlajacy produkty i przed wyswietlenim nagwka i  stopki
 * nalezy sprawdzic czy wywoanie odbyo si przez ajax'a. W innym wypadku zostanie w miejscu
 * produktw producenta wyswietlona caa strona zwrcona przez serwer.
 *
 *  {towary_producenta producent_id=12 ajax=true}
 *
 *
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

require_once ('Cache/Lite.php');

function smarty_function_towary_producenta($params, &$smarty){
    global $dbh1, $KATALOG_PHOTO, $KATALOG_DOST;

    $producent_id = 0;
    foreach( array('producent_id', 'id_producenta', 'producent' ) as $k ){
        if ( isset($params[$k]) ) {
            $producent_id = intval($params[$k]);
        }
    }

    if ( empty($producent_id) ) {
        return false;
    }

    $ilosc = 10;
    if ( !empty($params['ilosc']) ) {
        $ilosc = intval($params['ilosc']);
        if( $ilosc <= 0 || $ilosc > 100 ){
            $ilosc = 10;
        }
    }

    if ( empty($params['ajax']) ) {
        // Create a Cache_Lite object
        $Cache_Lite = new Cache_Lite(array(
            'cacheDir' => TEMP_DIR . '/cache/', 'lifeTime' => 43200,
        ));

        $output = '';
        $cache_id = 'plugin:towary_producenta(' . $producent_id . ')';

        if ( true || ( !($data = $Cache_Lite->get($cache_id)) || !empty($params['nocache']) ) && is_resource($dbh1) ) {
            // No valid cache found (you have to make the page)
            // Cache miss !
            $towary = $where = $tables = array();
            RaksTowarClass::towary_where( $tables, $where, 0, 0 );

            if ( (!empty($params['dostepne']) || !empty($KATALOG_DOST)) && empty($where['dost']) ) {
                RaksTowarClass::dostepne_warunek( $tables, $where );
            }

            if(  !empty($KATALOG_PHOTO)  ) {
                $where['photo'] = ' (a.RYSUNEK != 0 OR ((SELECT count(*) FROM R3_ATTACHMENTS WHERE ATTACHMENT_GROUP_ID = a.GUID AND (NAME LIKE \'%%.jpg\' OR NAME LIKE \'%%.gif\' OR NAME LIKE \'%%.png\') ) > 0))';
            }

            $where['producent'] = 'a.PRODUCENT = ' . intval($producent_id);
            if ( !empty($params['random']) || !empty($params['losowo']) ) {
                $seed = mt_rand();
                $where['order_by'] = '(a.ID + '.$seed.')*4294967291-((a.ID + '.$seed.')*4294967291/49157)*49157';
            } else {
                $where['order_by'] = 'a.NAZWA';
            }

            $query = make_select( $tables, 'FIRST ' . $ilosc . ' SKIP 0 a.ID_TOWARU ', $where ) ;

            $towary_info = towary_info( $query, array(
                //informacja o producencie
                'producent' => true,
                //informacja i promocji i cenie promocyjnej
                'promocja'  => true,
                //informacja i wyprzedazy i cenie dla wyprzedazy
                'wyprzedaz' => true,
                //informacja o stanie towaru
                'dostepnosc' => true,
                //informacja o zdjeciu
                'zdjecie' => true,
                'priorytet_cen' => false,
                //jesli towar ma cene promocyjna wwczas zostanie ona wpisana do pola CENA i CENA_BRUTTO towaru
                'ceny_promocyjne' => false,
            ));
            $towary = $towary_info['towary'];

            $Cache_Lite->save(serialize($towary));
        } else if( $data ){
            $towary = unserialize( $data );
        } else {
            return;
        }

        //mozna przekazac do szablonu i wywietlanie zrealizowa w szablonie
        $smarty->assign_by_ref( 'towary_producenta', $towary );


        if ( $towary ) {
            $SZABLON_URL = $smarty->get_template_vars('SZABLON_URL');

            $output .= '<h3>Towary producenta: </h3>';

            //wywietlam maksymalnie 10 towarw
            $output .= '<table class="data" width="95%" cellspacing="0" cellpadding="2" border="0">'."\n";
            $output .= '<tr class="head">'."\n";
            $output .= '   <th width="20px">Lp.</th>'."\n";
            $output .= '   <th colspan="2">Nazwa</th>'."\n";
            $output .= '   <th width="10%" >Cena</th>'."\n";
            $output .= '	 <th width="15%" >Opis</th>'."\n";
            $output .= '</tr>'."\n";

            for ( $j = $i = 0, $lp = count($towary); $i < $lp && $j < 10 ; $i++ ) {
              if ( !empty($towary[$i]['CENA_BRUTTO']) ){
                $j++;

                $towar_url = URL_PATH.'/'.$towary[$i]['NAZWA_URL'].'-t-'.$towary[$i]['ID'].'.html';

                $output .= '<tr class="'.( $i % 2 ? 'odd' : 'even' ).'" >'."\n";
                $output .= '   <td align=right><a class="product" href="'.$towar_url.'">'.($j).'.</a> </div></td>'."\n";
                $output .= '   <td width="25px" style="padding:5px 10px;"><a href="'.$towar_url.'"><img class="obrazek micro" src="'.IMAGES_URL.'/obrazki/mini/'.$towary[$i]['RYSUNEK'].'.jpg" onmouseover="img_preview_show_no_ajax( this, \''.IMAGES_URL.'/obrazki/small/'.$towary[$i]['RYSUNEK'].'.jpg\', \'\', \'\')" onmouseout="img_preview_hide();" alt="" /></a></td>'."\n";
                $output .= '   <td>'."\n";
                if( $towary[$i]['PRODUCENT'] ){
                    $output .= '     <a class="product" href="'.URL_PATH.'/'.$towary[$i]['PRODUCENT_NAZWA_URL'].'-p-'.$towary[$i]['PRODUCENT'].'.html">'.$towary[$i]['PRODUCENT_NAZWA'].'</a><br />'."\n";
                }
                $output .= '     <a href="'.$towar_url.'">'.$towary[$i]['NAZWA'].'</a><br>'."\n";
                $output .= '   </td>'."\n";
                $output .= '   <td align=right><b title="cena brutto">'.currency_format($towary[$i]['CENA_BRUTTO']).'</b><br /><small title="cena netto">'.currency_format($towary[$i]['CENA']).'</small></td>'."\n";
                $output .= '   <td align="center">'."\n";

                if ( $towary[$i]['OBRAZ'] ) {
                    $output .= '     <img title="Ze zdjciem" src="'.$SZABLON_URL.'/images/icons/ico-obraz.png" alt="" />'."\n";
                }

                if ( $towary[$i]['UWAGI'] ) {
                    $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-opis.png" alt="" />'."\n";
                }

                if ( $towary[$i]['ILOSC'] ) {
                    $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-jest.png" alt="" />'."\n";
                } else {
                    $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-brak.png" alt="" />'."\n";
                }

                if ( $towary[$i]['PROMOCJA'] ) {
                    $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-promo.png" alt="" />'."\n";
                }

                $output .= '   </td>'."\n";
                $output .= '</tr>'."\n";

              }
            }

            $output .= '</table>';
        }
    } else {
        $output .= '<h3>Towary producenta: </h3>';
        //wywietlam maksymalnie 10 towarw
        $output .= '<div id="towary_producenta"></div>'."\n";
        $output .= '<script type="text/javascript">'."\n";
        $output .= '

function towary_producenta( url, params ){
    jQuery.get( url, params, function(data, textStatus, jqXHR ){
      jQuery(\'#towary_producenta\').html(data);

      jQuery(\'#towary_producenta\').find(\'th a\').click(function(){
          towary_producenta ( this.href, {ajax : true, na_stronie : '.$ilosc.' } );
          return false;
      });

      jQuery(\'#towary_producenta\').find(\'#katalog_paginacja a\').click(function(){
          towary_producenta ( this.href, {ajax : true, na_stronie : '.$ilosc.' });
          return false;
      });

      jQuery(\'#towary_producenta\').find(\'form\').submit(function(){
          var adres = \''.URL_PATH.'/index.php?action=katalog&ajax=1&producent='.$producent_id.'\';
          var values = new Object();

          jQuery(\':input\', this).each(function() {
            var type = this.type;
            if (type == \'checkbox\' || type == \'radio\' ){
                values[this.name] = ( this.checked ) ? this.value : null;
            }else{
                values[this.name] = this.value;
            }
          });
          values.ajax = true;
          if( !values.na_stronie )
          values.na_stronie = '.$ilosc.';

          //console.log(values);
          towary_producenta ( adres, values );
          return false;
      });

      jQuery(\'#katalog_paginacja\').find(\'input[type=text]\').each(function(){
          this.onblur = function(){};
          this.onchange = function(){};
      }).blur(function(){return false;}).change(function(){return false;});;

    }, \'html\' );
}

jQuery(function(){
    towary_producenta( \''.URL_PATH.'/index.php\', {action: \'katalog\', na_stronie : '.$ilosc.', ajax : true, producent : '.$producent_id.' } );
});
        '."\n";

        $output .= '</script>'."\n";
    }

    return $output;
}
/***************************************************************************************************
 *
 *  Przykad jak mozna wyswietlic towary zamawiane z danym produktem w szablonach smarty
 *
 */

/*
<h3>Klienci, ktrzy kupili ten twar kupili rwnie: </h3>

<table class="data" cellpadding="0" cellspacing="0" >
  <tr class="head">
      <th colspan="2">Nazwa</th>
      <th width="10%" >Cena</th>
	  <th width="15%" >Opis</th>
  </tr>

  {foreach from=$towary_zamowione item=towar name=towary_zamowione}
   <tr class={cycle values="odd,even"} >
      <td width="25px" style="padding:5px 10px;"> <a href="{$MAIN_URL}/action_towar/mode_show/ID_{$akcesorium.ID}/{$towar.NAZWA_URL}"><img class = "obrazek micro" src='{$IMAGES_URL}/obrazki/mini/{$towar.RYSUNEK}.jpg' onmouseover="img_preview_show_no_ajax( this, '{$IMAGES_URL}/obrazki/small/{$towar.RYSUNEK}.jpg', '', '')" onmouseout="img_preview_hide();" alt=''></a> </td>
      <td ><a href='{$MAIN_URL}?action=towar&amp;mode=show&amp;ID={$towar.ID}' >{$towar.NAZWA}</a></td>
      <td align=right><b title="cena brutto">{$towar.CENA_BRUTTO|currency_format}</b><br /><small title="cena netto">{$towar.CENA|currency_format}</small></td>
      <td  align='center'>
       {if $towar.RYSUNEK }<img title="Ze zdjciem" src='{$SZABLON_DIR}/images/icons/ico-obraz.png' alt=''> {/if}
  	   {if $towar.UWAGI } <img title="Z opisem" src='{$SZABLON_DIR}/images/icons/ico-opis.png' alt=''> {/if}
       {if $towar.ILOSC } <img title="Brak w magazynie" src='{$SZABLON_DIR}/images/icons/ico-brak.png' alt=''> {else} <img title="Jest w magazynie" src='{$SZABLON_DIR}/images/icons/ico-jest.png'> {/if}
  	   {if $towar.PROMOCJA } <img title="W promocji" src='{$SZABLON_DIR}/images/icons/ico-promo.png' alt=''> {/if}
      </td>
    </tr>
  {/foreach}

  <tr>
    <td colspan="4">
      {include file="legenda.tpl"}
    </td>
  </tr>
</table>

*/
