/**
 * jQuery progress plugin
 *
 * Plugin do obsugi progresbarw koystajcych z Komponentu ProgressbarComponent
 * zapisujcego parametry wykonywanych akcji do pliku w formacie JSON.
 * Plugin generuje gotowy html z progresbarami i obsuguje zapytania ajaxowe.
 * Dostpna jest moliwo definiowania wasnych komunikatw. Naley jednak zachowa
 * format do sprintf().
 *
 * !IMPORTANT do pluginu naley przekaza relatywny adres do akcji generujcej
 * rozpoczcie procesu (zawierajcej $this->Progressbar->start($aData)).
 *
 * @example $('#progressbar_container')
 *          .progress({
 *              urls:{
 *                   start:"allegro/allegro_categories/startUpdate"
 *              }
 *          });
 *
 */
;
(function($){
    /**
     * Selector
     */
    var _this = null;
    /**
     * Elementy html w postaci obiektw
     */
    var _elements = {};
    /**
     * Nazwa pliku procesu
     */
    var _filename = '';
    /**
     * Zmienna odpowiedzialna za obsug setInterval()
     */
    var _interval = null;
    /**
     * Ilo akcji pobierana w pierwszym ajax'ie
     */
    var _actions = 0;
    /**
     * Zmienna przechowujca opcje
     * @todo Jak przekaza opcje do setTime()
     */
    var _options;


    $.fn.progress = function(options)
    {
        /**
         * Opcje pluginu (Komunikaty i cieki url do akcji)
         */
        options = $.extend(
            true,{
                messages:{
                    info:" %s %s / %s. Czas cakowity: %s ",
                    infoAction:" %s. Czas cakowity: %s ",
                    infoFinished:"Operacja zakoczona pomylnie. Czas cakowity: %s ",
                    infoStopped:"Operacja zostaa anulowana",
                    infoError:"Wystpiy bdy. Prosz sprbowa jeszcze raz.",
                    buttonExit : "Zamknij",
                    buttonStop : "Stop",
                    dialogTitle : "Process"
                },
                urls:{
                    start:"",
                    stop:"progress.php?stop=1&file=",
                    get:"progress.php?file="
                }
            }, options || {});



        if( !options.urls.start  ){
            if ( this.is('a') ) {
                options.urls.start = this.attr('href');
            } else if ( this.is('form') ) {
                options.urls.start = this.attr('action');
            }else if ( this.is('input[type=submit]') ) {
                options.urls.start = this.parents('form').attr('action')
            }
        }

        _this = this;
        _options = options;
        appendHtml(options);
        setUp(options);
    }
    /**
     * Generowanie html'u i przypicie go do selektora
     */
    function appendHtml(options){
        //console.log('appendHtml');

        _elements.dialog = $('<div>');
        _elements.dialog.addClass('progress-container').appendTo('body');
        _elements.dialog.dialog({
            autoOpen: false,
            modal:true,
            width:600,
            height:250,
            closeOnEscape:false,
            resizable:false,
            title:options.messages.dialogTile
        });
        /**
         * Kontener
         */
        _elements.div = $('<div>');
        _elements.div.css('display','none');
        _elements.dialog.append(_elements.div);

        /**
        * Gwny kontenter progressbar'u
        */
        _elements.bar_all = $('<span>');
        _elements.bar_all.addClass('progress-bar main');
        _elements.div.append(_elements.bar_all);
        /**
        * Span ze zmieniajc si dugoci
        */
        _elements.progress_all = $('<span>');
        _elements.progress_all.css('width','0%').text('0%');
        _elements.bar_all.append(_elements.progress_all);
        /**
        * Paragraf na komunikaty
        */
        _elements.info_all = $('<p>');
        _elements.div.append(_elements.info_all);
        /**
        * Przycisk stop
        */
        _elements.stop_btn = $('<a>');
        _elements.stop_btn.addClass('progress-button').text(options.messages.buttonStop);
        _elements.div.append(_elements.stop_btn);

        _elements.exit_btn = $('<a>');
        _elements.exit_btn.addClass('progress-button').text(_options.messages.buttonExit).click(function(){
            _elements.dialog.dialog('close');
        });
        _elements.div.append(_elements.exit_btn);


        /**
         * Loader
         */
        _elements.loader = $('<div>');
        _elements.loader.addClass('progress-loading');
        _elements.dialog.append(_elements.loader);

    }
    /**
     * Dodanie dodatkowego progresbaru na podrzdne akcje
     */
    function apendActionBar(){
        //console.log('apendActionBar');

        _elements.bar_current = $('<span>');
        _elements.bar_current.addClass('progress-bar');

        _elements.progress_current = $('<span>');
        _elements.progress_current.css('width','0%').text('0%');
        _elements.bar_current.append(_elements.progress_current);

        _elements.info_current = $('<p>');
        _elements.stop_btn.before(_elements.bar_current);
        _elements.stop_btn.before(_elements.info_current);
    }
    /**
    *  Rozpoczcie procesu
    */
    function setUp(options){
        var element = _this, eventType = 'click';

        if ( _this.is ('form') ) {
            eventType = 'submit';
        } else if ( _this.is('input[type=submit]') ) {
            element = _this.parents('form');
            eventType = 'submit';
        }

        element.bind(eventType, progressRequest );
    }

    function progressRequest( e ){
        e.preventDefault();

        //_this.fadeOut().remove();

        var form_data = null, ajax_type = 'GET';
        if ( $(this).is('form') ){
            form_data = new Object();

            var $form = $( this  ), i = 0;
            var some_data = $form.find("input, select").map(function(){
                if( $(this).attr('type') == 'checkbox' ){
                    return {name: $(this).attr('name'), value: this.checked ? $(this).val() : 0 };
                } else {
                    return {name: $(this).attr('name'), value: $(this).val()};
                }
            }).get();

            ajax_type = $form.attr('method');
            if( !ajax_type ){ajax_type = 'GET'}

            for( i = 0; i < some_data.length; i++  ){
                if( some_data[i].name )
                    form_data[some_data[i].name] = some_data[i].value;
            }

            //console.log(form_data);
            //return false;
        }

        _elements.stop_btn.fadeIn();
        _elements.exit_btn.css({ 'visibility':'hidden'});
        //console.log(_elements.exit_btn);

        _elements.dialog.dialog('open');
        $('.ui-dialog-titlebar-close').remove();
        _elements.div.fadeIn('slow');

        $.ajax({
            'url': _options.urls.start,//Pierwszy ajax rozpoczynajcy proces
            'data' : form_data,
            'type' : ajax_type.toUpperCase(),
            'success': function(data){
                if ( !data || !data.filename || !data.actions ) {
                    _elements.dialog.dialog('close');
                    display_message( data, 'error');
                    return false;
                }

                _elements.loader.hide();
                _filename = data.filename;
                _actions = data.actions;

                if ( _actions > 1 ) {
                    apendActionBar();
                }
                setTime();
                _elements.stop_btn.click(function(){
                    $.getJSON(BASE_URL + _options.urls.stop + _filename);//zatrzymanie procesu
                });
            },
            dataType : "JSON"
        });

        return false;
    }

    /**
     * Ustawienie akcji wywoywanej w interwale czasowym
     */
    function setTime(){
        _interval = setInterval(function(){
            $.getJSON(
                BASE_URL + _options.urls.get+_filename,//pobieranie informacji o stanie procesu
                function(data){
                    if(data){
                        if(data.status=="stopped"){
                            setupExit(_options.messages.infoStopped);
                        }
                        else if(data.status=="finished"){
                            _elements.progress_all.css('width','100%').text('100%');
                            setupExit($.sprintf(_options.messages.infoFinished,data.time));
                        }else if(data.status=="error"){
                            setupExit(_options.messages.infoError+":<br />"+data.error);
                        }else if( data.current ){
                            updateBar(data,_options);//jeeli status active aktualizacja progresbarw
                        }
                    }else{
                        clearInterval(_interval);
                    }
                }
                );
        }, 1500);
    }

    /**
    *  Zakoczenie procesu
    */
    function setupExit(message){
        _elements.info_all.html(message);
        if ( _actions > 1 ){
            _elements.bar_current.remove();
            _elements.info_current.remove();
        }
        clearInterval(_interval);

        _elements.stop_btn.fadeOut();
        _elements.exit_btn.css({ 'visibility': 'visible'});

    }
    /**
     * Aktualizacja progresbarw
     */
    function updateBar(data,options){
        var paction = parseInt(data.current.percent);
        var pall = parseInt( paction / parseInt(data.all.actions))+(( data.all.current / data.all.actions)*100);
        _elements.progress_all.css('width',pall+'%').text(pall+'%');
        if(_actions > 1){
            _elements.info_all.html($.sprintf(options.messages.info,data.all.name,(data.all.current+1),data.all.actions,data.all.time));
            _elements.progress_current.css('width',paction+'%').text(paction+'%');
            _elements.info_current.html($.sprintf(options.messages.infoAction,data.current.name + (data.current.comment ? (': ' + data.current.comment): ''),data.current.time));
        }else{
            _elements.info_all.html($.sprintf(options.messages.infoAction,data.current.name + (data.current.comment ? (': ' + data.current.comment): ''),data.current.time));
        }
    }
})(jQuery);