// JavaScript Document
function hasOptions( obj ){
    if (obj!=null && obj.options!=null) {
        return true;
    }

    return false;
}

function sortSelect(obj) {
    var o = new Array();

    if ( hasOptions(obj) ){
        for (var i=0; i<obj.options.length; i++) {
            o[o.length] = new Option( obj.options[i].text, obj.options[i].value, obj.options[i].defaultSelected, obj.options[i].selected) ;
        }

        if ( o.length == 0 ){ return; }

        o = o.sort(
            function(a,b) {
                if ((a.text+"") < (b.text+"")) { return -1; }
                if ((a.text+"") > (b.text+"")) { return 1; }
                return 0;
            }
        );

        for ( var i = 0; i < o.length; i++ ){
            obj.options[i] = new Option(o[i].text, o[i].value, o[i].defaultSelected, o[i].selected);
        }
    }
}

function removeAllOptions(from) {
  	if ( !hasOptions(from) ){ return; }

  	for (var i = (from.options.length-1); i >= 0; i-- ){
  	   from.options[i] = null;
  	}

  	from.selectedIndex = -1;
}

function copyOptions(from, to) {
    var options = new Object();

    if ( hasOptions(to) ){
        for( var i = 0; i < to.options.length; i++ ){
          options[to.options[i].value] = to.options[i].text;
        }
    }

    if (!hasOptions(from))  return;

    var index = ( hasOptions(to) ) ? to.options.length : 0;
    
    for( var i = 0; i < from.options.length; i++ ){
        var o = from.options[i];
        
        if( options[o.value] == null || options[o.value] == "undefined" || options[o.value] != o.text ){
            to.options[index++] = new Option( o.text, o.value, false, false);
        }
    }

    if( (arguments.length < 3) || (arguments[2] == true) ){
       sortSelect(to);
    }
    
    to.selectedIndex = from.selectedIndex = -1;
}

function copyOptions(from, to) {
    

    if ( hasOptions(to) ){
        for( var i = 0; i < to.options.length; i++ ){
          options[to.options[i].value] = to.options[i].text;
        }
    }

    if (!hasOptions(from))  return;

    var index = ( hasOptions(to) ) ? to.options.length : 0;

    for( var i = 0; i < from.options.length; i++ ){
        var o = from.options[i];

        if( options[o.value] == null || options[o.value] == "undefined" || options[o.value] != o.text ){
            to.options[index++] = new Option( o.text, o.value, false, false);
        }
    }

    if( (arguments.length < 3) || (arguments[2] == true) ){
       sortSelect(to);
    }

    to.selectedIndex = from.selectedIndex = -1;
}

