
/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_SESSIONS (
    ID     ID_D NOT NULL /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    SID    WWW_SESJA_D NOT NULL /* WWW_SESJA_D = CHAR(32) NOT NULL */,
    DATA   BLOB SUB_TYPE 1 SEGMENT SIZE 512,
    CDATE  DATA_TIME_D NOT NULL /* DATA_TIME_D = TIMESTAMP */,
    MDATE  DATA_TIME_D NOT NULL /* DATA_TIME_D = TIMESTAMP */
);




/******************************************************************************/
/****                          Unique Constraints                          ****/
/******************************************************************************/

ALTER TABLE WWW_SESSIONS ADD CONSTRAINT WWW_SESSIONS_SID_UNQ UNIQUE (SID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_SESSIONS_DATY_IND ON WWW_SESSIONS (CDATE, MDATE);


/* Fields descriptions */

DESCRIBE FIELD ID TABLE WWW_SESSIONS
'Wzr typu dla pl zawierajcych identyfikator rekordu (musi zawiera warto)';

DESCRIBE FIELD CDATE TABLE WWW_SESSIONS
'Wzorzec dla pl zawierajcych dat i czas';

DESCRIBE FIELD MDATE TABLE WWW_SESSIONS
'Wzorzec dla pl zawierajcych dat i czas';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT SELECT, INSERT, UPDATE, DELETE ON WWW_SESSIONS TO WWW_ROLE;
